static GList *prop_select_list=NULL;
static void get_prop_select(GtkTreeModel * model, GtkTreePath * path, GtkTreeIter * iter, gpointer data)
{
    GtkTreeView *treeview = (GtkTreeView *) data;
    GtkTreeModel *treemodel = gtk_tree_view_get_model(treeview);
    record_entry_t *en;
    gtk_tree_model_get(treemodel, iter, ENTRY_COLUMN, &en, -1);
    if(!en || !IS_PATH(en->type)) return;
    prop_select_list = g_list_append(prop_select_list, en);
    return;
}

static
void 
private_on_prop_activate(GtkMenuItem * menuitem, gpointer user_data) {
    GtkTreeView *treeview = xffm_details->arbol->treestuff[get_active_tree_id()].treeview;
    GtkTreeSelection *selection = gtk_tree_view_get_selection(treeview);
    if (prop_select_list) g_list_free(prop_select_list);
    gtk_tree_selection_selected_foreach(selection, 
		    get_prop_select, (gpointer) treeview); 
   PROP_do_prop(&(xffm_details->arbol->widgets),prop_select_list);
#ifndef LINKED_MODULES
   unload_prop_module();
#endif
     g_list_free(prop_select_list);
     prop_select_list=NULL;
   local_monitor(TRUE);
}
static
void private_glob_activate(GtkMenuItem * menuitem, gpointer user_data)
{
    FIND_do_find((GtkWidget *) menuitem);
}

static
void tb_properties(GtkWidget * w) {
    private_on_prop_activate(NULL,NULL);
}


G_MODULE_EXPORT
void tb_find(GtkButton * button, gpointer user_data)
{
    FIND_do_find((GtkWidget *) button);
}

G_MODULE_EXPORT
void sb_find(GtkWidget * widget)
{
    tb_find((GtkButton *)widget,NULL);
}
G_MODULE_EXPORT
void on_properties_activate(GtkMenuItem * menuitem, gpointer user_data){
    private_on_prop_activate(menuitem, user_data);
}
G_MODULE_EXPORT
void on_find_activate(GtkMenuItem * menuitem, gpointer user_data){
    private_glob_activate(menuitem, user_data);
}


/*static
void on_view_find1_activate(GtkMenuItem * menuitem, gpointer user_data)
{
    tb_find((GtkButton *)menuitem,NULL);
}*/


/***********************************************************************************/
/*
static
void remove_menu_item (GtkWidget *widget, gpointer data){
    TRACE("removing 0x%x",(unsigned)widget);
    gtk_widget_destroy(widget);
}*/



 

static
GtkWidget * 
common_mk_popup_menu (	GtkWidget *parent,
			GtkAccelGroup *accel_group,
			void *data)
{
  /*GtkAccelGroup *accel_group;*/
  GtkWidget *w;
  GtkWidget *item22_menu;
  GtkWidget *file1_menu;
  GtkWidget *columns1_menu;
  

#ifdef USE_ACCEL_LABELS
  if (!accel_group) {
    accel_group = gtk_accel_group_new ();
    gtk_window_add_accel_group (GTK_WINDOW (window), accel_group);
  }
#endif
  
  item22_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  "item22", /* label */
	  "item22",   /* name */
	  parent, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/
  w=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  "", /* label */
	  "module1",   /* name */
	  item22_menu, 	  /* parent */
	  NULL,	/* callback (or NULL)*/
	  NULL); /* iconfile (or NULL)*/

  /* common menu items */

   {
    gchar *string[5]={N_("Go back"),N_("Reload"),N_("Go to"),N_("Home"),NULL};
    gchar *iconfile[5]={"xfce/stock_go-back","xfce/stock_refresh","xfce/stock_jump-to", "xfce/stock_home",NULL};
    gchar *id[5]={"go_back_menuitem","refresh3","goto2","home2",NULL};
    void *callback[5]={on_back2_activate,treeview_refresh_activate,on_jump_to2_activate,on_home3_activate,NULL};
    guint akey[5]={GDK_Left,GDK_z,GDK_Down,GDK_End,0};
    int i;

    for (i=0; string[i]; i++){
 	gui_add_menu_item(&(xffm_details->arbol->widgets),
		    item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
   }
#if 0
    gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		OUR_HOST_NAME(&(xffm_details->arbol->widgets.window)), 
		"xfce/stock_system","host2", 
		private_host_activate, 
		data,
		accel_group, GDK_End, GDK_CONTROL_MASK);
#endif
    
   {
    gchar *string[3]={N_("Detailed view"),N_("Icon view"),NULL};
    gchar *iconfile[3]={"xfce/stock_indent","xfce/b-iconview",NULL};
    gchar *id[3]={"opentreeview","openiconview",NULL};
    void *callback[3]={on_open_in_xffm_activate,on_iconview_activate,NULL};
    guint akey[3]={GDK_n,0,0};
    int i;

    for (i=0; string[i]; i++){
 	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
   }

   

   {
    gchar *string[4]={N_("Open with ..."),"","",NULL};
    gchar *iconfile[4]={"xfce/stock_open","xfce/stock_run","xfce/stock_run",NULL};
    gchar *id[4]={"open_with_menuitem","autotype_R","autotype_Prun",NULL};
    void *callback[4]={on_open_with_activate,on_autotype_R,NULL,NULL};
    guint akey[4]={GDK_o,0,0,0};
    int i;

    for (i=0; string[i]; i++){
 	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
   }

   w=gui_add_menu_separator(item22_menu);
   GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator00");
   w = gtk_check_menu_item_new_with_mnemonic (_("Show hidden"));
  gtk_widget_show (w);
  gtk_container_add (GTK_CONTAINER (item22_menu), w);
  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "show_hidden_menuitem");

  w = gtk_check_menu_item_new_with_mnemonic (_("Preview images"));
  gtk_container_add (GTK_CONTAINER (item22_menu), w);
  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "preview_images_menuitem");
  gtk_widget_show (w);
  
    w=gui_add_menu_separator(item22_menu);
    GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator_cut");
    
    /* abstract menu items */
    
   {
    gchar *string[7]={N_("Cut"),N_("Copy"),N_("Paste"),N_("Paste link"),N_("Remove"),N_("Properties"),NULL};
    gchar *iconfile[7]={"xfce/stock_cut","xfce/stock_copy","xfce/stock_paste","xfce/stock_pastelink","xfce/stock_delete","xfce/stock_properties",NULL};
    gchar *id[7]={"cut_menuitem","copy_menuitem","paste_menuitem","pastelink_menuitem","remove_menuitem","properties2",NULL};
    void *callback[7]={treeview_cut_activate,treeview_copy_activate,treeview_paste_activate,treeview_pastelink_activate,treeview_remove_activate,private_on_prop_activate,NULL};
    guint akey[7]={GDK_x,GDK_c,GDK_v,0,GDK_Delete,GDK_i,0};
    guint amask[7]={GDK_CONTROL_MASK, GDK_CONTROL_MASK, GDK_CONTROL_MASK,0,0, GDK_CONTROL_MASK,0};
    int i;

    for (i=0; string[i]; i++){
 	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], amask[i]);
    }
   }
   
   w=gui_add_menu_separator(item22_menu);
   GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator_single_selections");
   file1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("File"), /* label */
	  "file1",   /* name */
	  item22_menu, 	  /* parent */
	  NULL,	/* callback (or NULL)*/
	  "xfce/convert"); /* iconfile (or NULL)*/
   

   /* file group of menu items */
  {
    gchar *string[8]={N_("Print"),N_("Duplicate"),N_("Symlink"),N_("Touch"),N_("Rename"),N_("Scramble"),N_("Unscramble"),NULL};
    gchar *iconfile[8]={"xfce/stock_print","xfce/stock_dnd-multiple","xfce/stock_convert","xfce/stock_index","xfce/stock_save-as","xfce/stock_no","xfce/stock_yes",NULL};
    gchar *id[8]={"print_menuitem","duplicate_menuitem","symlink_menuitem","touch_menuitem","rename_menuitem","scramble_menuitem","unscramble_menuitem",NULL};
    void *callback[8]={treeview_print_activate,treeview_duplicate_activate,treeview_symlink_activate,treeview_touch_activate,treeview_rename_activate,on_scramble_activate,on_unscramble_activate,NULL};
    guint akey[8]={GDK_p,GDK_d,GDK_s,GDK_m,GDK_r,0,0,0};
    int i;

    for (i=0; string[i]; i++){
	gui_add_menu_item(&(xffm_details->arbol->widgets),(i<2?item22_menu:file1_menu),
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
  }
 
  
  columns1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Columns"), /* label */
	  "columns1",   /* name */
	  item22_menu, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/


  /* operations group of menu items */
  {
    gchar *string[5]={N_("Mount"),N_("Unmount"),N_("New file"),N_("New directory"),NULL};
    gchar *iconfile[5]={"xfce/stock_yes","xfce/stock_no","xfce/stock_new-tab","xfce/stock_new-dir",NULL};
    gchar *id[5]={"mountP","unmountP","newfile_menuitem","newdirectory_menuitem",NULL};
    void *callback[5]={NULL,NULL,on_newfile_activate,on_newdir_activate,NULL};
    guint akey[5]={0,0,GDK_Insert,GDK_Insert,0};
    guint amask[6]={0, 0, GDK_CONTROL_MASK, GDK_MOD1_MASK, 0};
    int i;

    for (i=0; string[i]; i++){
	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], amask[i]);
    }
  }
 
 
  /* execution group of menuitems */
  
    w=gui_add_menu_separator(item22_menu);
    GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator0");

  {
    gchar *string[5]={N_("Terminal"),N_("Run"),N_("Find"),N_("Differences"),NULL};
    gchar *iconfile[5]={"xfce/stock_terminal","xfce/stock_run","xfce/b-find","xfce/xfdiff",NULL};
    gchar *id[5]={"terminal2","run2","find2","differences2",NULL};
    void *callback[5]={on_open_in_terminal_activate,treeview_run_activate,private_glob_activate,on_differences_activate,NULL};
    guint akey[5]={GDK_t, GDK_e, GDK_f, GDK_h, 0};
    int i;

    for (i=0; string[i]; i++){
	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
  }
    
    w=gui_add_menu_separator(item22_menu);
    GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator1");
    
    /* select group of menuitems: */
  {
    gchar *string[4]={N_("Select all"),N_("Unselect all"),NULL};
    gchar *iconfile[4]={"xfce/stock_add","xfce/stock_remove",NULL};
    gchar *id[4]={"select_all_menuitem", "unselect_all_menuitem",NULL};
    void *callback[4]={private_select_all_activate, private_unselect_all_activate, NULL};
    guint akey[4]={GDK_a, GDK_u, 0};
    int i;

    for (i=0; string[i]; i++){
	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
  }

  
   w=gui_add_menu_separator(item22_menu);
    GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, w, "iv_separator2");
    
    /* general group of menuitems: */

#ifdef HAVE_LIBXFCE4MCS_CLIENT
    gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _("Global Configuration"),
		    "xfce/xfce-setting-show",
		    "settings2",
		    on_xfce_setting_show,
		    data,
		    accel_group, GDK_c, GDK_MOD1_MASK);
#endif

  {
    gchar *string[12]={N_("Delete all trash"),N_("Clear"),N_("Clear"),N_("Remove item from results"),N_("Remove item from trash"),N_("Hide branch"),N_("Collect trash"),N_("Preview this image"),N_("Disk usage"),N_("About"),N_("Exit"),NULL};
    gchar *iconfile[12]={"xfce/stock_warning","xfce/stock_clear","xfce/stock_clear","xfce/stock_undo","xfce/stock_undo","xfce/stock_cancel","xfce/stock_undelete","xfce/stock_preview","xfce/disk","xfce/stock_about","xfce/stock_quit",NULL};
    gchar *id[12]={"delete_all_trash1_menuitem","uncollect_trash1_menuitem","clear_all_results_menuitem","remove_from_results_menuitem","uncollect_from_trash_menuitem","hide_branch_menuitem","collect_trash1_menuitem","preview_this_image_menuitem","popup_disk_usage_menuitem","about2","exit2",
NULL};
    void *callback[12]={on_delete_all_trash,on_uncollect_trash,on_clear_all_results_activate,on_remove_from_results_activate,on_uncollect_from_trash_activate,hide_branch_activate,on_collect_trash1_activate,on_preview_this_image_activate,on_countfiles_activate, gui_on_about_activate,gui_on_close_activate, NULL};
    guint akey[12]={0,0,0,0,0,0,0,0,GDK_Y, 0, GDK_Q, 0};
    int i;

    for (i=0; string[i]; i++){
	gui_add_menu_item(&(xffm_details->arbol->widgets),item22_menu,
		    _(string[i]),
		    iconfile[i],
		    id[i],
		    callback[i],
		    data,
		    ((akey[i])?accel_group:NULL),akey[i], GDK_CONTROL_MASK);
    }
  }
    
 

  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, item22_menu, "item22_menu");
  return item22_menu;

}


static
GtkWidget * 
common_mk_main_menu (	GtkWidget *parent,
			GtkAccelGroup *accel_group)
{
  GtkWidget *main_menu2_menu;
  GtkWidget *open1_menu;
  GtkWidget *go1_menu;
  GtkWidget *tools1_menu;
  GtkWidget *options1_menu;
  GtkWidget *edit_themes1;
  GtkWidget *about1;
  GtkWidget *salir2;

  main_menu2_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Main menu"), /* label */
	  "main_menu2",   /* name */
	  parent, 	  /* parent */
	  on_set_menu_context,NULL); /* callback (or NULL)*/
  tools1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Tools"), /* label */
	  "tools1",   /* name */
	  main_menu2_menu, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/
  open1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Open"), /* label */
	  "open1",   /* name */
	  main_menu2_menu, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/
  go1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Go"), /* label */
	  "go1",   /* name */
	  main_menu2_menu, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/
  options1_menu=gui_mk_menu(
	  &(xffm_details->arbol->widgets),
	  _("Options"), /* label */
	  "options1",   /* name */
	  main_menu2_menu, 	  /* parent */
	  NULL,NULL); /* callback (or NULL)*/


  edit_themes1 = gtk_menu_item_new_with_mnemonic (_("Edit themes"));
  gtk_widget_show (edit_themes1);
  gtk_container_add (GTK_CONTAINER (options1_menu), edit_themes1);
  g_signal_connect ((gpointer) edit_themes1, "activate",
                    G_CALLBACK (on_edit_themes),
                    NULL);
  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, edit_themes1, "edit_themes1");

  gui_add_menu_separator(main_menu2_menu);
#if 10

  about1 = gtk_image_menu_item_new_with_mnemonic (_("About"));
  gtk_widget_show (about1);
  gtk_container_add (GTK_CONTAINER (main_menu2_menu), about1);


  salir2 = gtk_image_menu_item_new_with_mnemonic (_("Exit"));
  gtk_widget_show (salir2);
  gtk_container_add (GTK_CONTAINER (main_menu2_menu), salir2);
  if (accel_group) gtk_widget_add_accelerator (salir2, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);
  gui_mk_pixmap_menu(&(xffm_details->arbol->widgets), "xfce/stock_about",about1,MENU_PIXMAP);
  gui_mk_pixmap_menu(&(xffm_details->arbol->widgets), "xfce/stock_quit",salir2,MENU_PIXMAP);
  g_signal_connect ((gpointer) about1, "activate",
                    G_CALLBACK (gui_on_about_activate),
                    NULL);
  g_signal_connect ((gpointer) salir2, "activate",
                    G_CALLBACK (gui_on_close_activate),
                    NULL);
  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, about1, "about1");
  GLADE_HOOKUP_OBJECT (xffm_details->arbol->widgets.window, salir2, "salir2");
#endif
  return main_menu2_menu;
}


