#include <gdk/gdkkeysyms.h>
extern 
void treeview_touch_activate(GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_duplicate_activate (GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_rename_activate(GtkMenuItem * menuitem, gpointer user_data);
extern 
void treeview_symlink_activate(GtkMenuItem * menuitem, gpointer user_data);


static
void sb_duplicate(GtkWidget *w){
    treeview_duplicate_activate((GtkMenuItem *)w,NULL);
}
static
void sb_symlink(GtkWidget *w){
    treeview_symlink_activate((GtkMenuItem *)w,NULL);
}
static
void sb_touch(GtkWidget *w){
    treeview_touch_activate((GtkMenuItem *)w,NULL);
}
static
void sb_rename(GtkWidget *w){
    treeview_rename_activate((GtkMenuItem *)w,NULL);
}
static
void sb_scramble(GtkWidget *w){
    on_scramble_activate((GtkMenuItem *)w,NULL);
}
static
void sb_unscramble(GtkWidget *w){
    on_unscramble_activate((GtkMenuItem *)w,NULL);
}


    smart_button_init_t exec_button_info[]={
      {"xfce/stock_terminal",N_("Terminal"),on_term,"sb_term",NULL,NULL,on_open_in_terminal_activate,GDK_T},
      {"xfce/stock_run",N_("Run"),sb_run,"sb_run",NULL,NULL,treeview_run_activate,GDK_E},
      {"xfce/b-find",N_("Find"),sb_find,"sb_find",NULL,NULL,on_find_activate,GDK_F},
      {"xfce/xfdiff",N_("Differences"),sb_diff,NULL,NULL,NULL,on_differences_activate,GDK_H},
      {"xfce/stock_print-preview",N_("Printer configuration"),sb_printer_configuration,NULL,NULL,NULL,on_printer_configuration_activate,0},
      {"xfce/stock_justify-fill",N_("List Pasteboard"),sb_list_pasteboard,NULL,NULL,NULL,treeview_list_pasteboard_activate,GDK_L},
      {"xfce/stock_clear",N_("Clear Pasteboard"),sb_clear_pasteboard,NULL,NULL,NULL,treeview_clear_pasteboard_activate,GDK_K},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t exec2_button_info[]={
      {"xfce/b-iconview",N_("Icon view"),sb_iconview,"sb_iconview",NULL,NULL,on_iconview_activate,GDK_J},
      {"xfce/b-treeview","xftree4",sb_new_win,NULL,NULL,NULL,on_new_win,GDK_N},
      {"xfce/b-network","xfsamba4",sb_new_smb,"sb_new_smb",NULL,NULL,on_new_smb,0},
      {"xfce/b-fstab","xffstab",sb_new_fstab,"sb_new_fstab",NULL,NULL,on_new_fstab,0},
      {"xfce/b-book","xfbook",sb_new_book,"sb_new_book",NULL,NULL,on_new_book,0},
      {"xfce/b-trash","xftrash4",sb_new_trash,"sb_new_trash",NULL,NULL,on_new_trash,0},
      {"xfce/b-recent","xfrecent",sb_new_recent,"sb_new_recent",NULL,NULL,on_new_recent,0},
      {"xfce/b-frequent","xffrequent",sb_new_frequent,"sb_new_frequent",NULL,NULL,on_new_frequent,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };


    smart_button_init_t go_button_info[]={
      {"xfce/stock_jump-to",N_("Go to"),goto_jump,"sb_goto_jump",NULL,NULL,on_jump_to2_activate,GDK_Down},
      {"xfce/stock_home",N_("Home"),go_home,"sb_go_home",NULL,NULL,on_home3_activate,GDK_Home},
      {"xfce/stock_go-back",N_("Back"),go_backward,"sb_go_backward",NULL,NULL,on_back2_activate,GDK_Left},
      {"xfce/stock_go-forward",N_("Forward"),go_forward,"sb_go_forward",NULL,NULL,on_forward2_activate,GDK_Right},
      {"xfce/stock_go-up",N_("Up"),go_up,"sb_go_up",NULL,NULL,on_up2_activate,GDK_Up},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };

    smart_button_init_t view_button_info[]={
      {"xfce/xfmime-edit",N_("Edit themes"),sb_xfmime_edit,"sb_xfmime_edit",NULL,NULL,NULL,0},
#ifdef FOOL_INTL
     {"xfce/stock_zoom-in",N_("Enlarge icons"),sb_zoom_in,"sb_zoom_in",NULL,NULL,on_zoom_in_activate,0},
     {"xfce/stock_zoom-out",N_("Shrink icons"),sb_zoom_out,"sb_zoom_out",NULL,NULL,on_zoom_out_activate,0},
#endif
      {"xfce/xfce-setting-show","xfce-setting-show",sb_xfce_setting_show,"xfce_setting_show",NULL,NULL,on_xfce_setting_show,0},
      {"xfce/stock_about",N_("About"),sb_about,"sb_about",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t new_button_info[]={
      {"xfce/stock_properties",N_("Properties"),tb_properties,"sb_properties",NULL,NULL,NULL,0},
      /*{"xfce/stock_new-tab",N_("New file"),tb_new,"sb_new_file",NULL,NULL,on_tb_new,0},*/
      {"xfce/stock_new-tab",N_("New file"),tb_new,"sb_new_file",NULL,NULL,NULL,0},
      /*{"xfce/stock_new-dir",N_("New directory"),tb_newd,"sb_new_dir",NULL,NULL,on_tb_newd,0},*/
      {"xfce/stock_new-dir",N_("New directory"),tb_newd,"sb_new_dir",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    
     smart_button_init_t single_selection_button_info[]={
      {"xfce/stock_print",N_("Print"),tb_print,"sb_print",NULL,NULL,NULL,0},
      {"xfce/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,NULL,0},
      {"xfce/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,NULL,0},
      {"xfce/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,NULL,0},
      {"xfce/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,NULL,0},
      {"xfce/stock_no",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,NULL,0},
      {"xfce/stock_yes",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
  
#if 0
     smart_button_init_t single_selection_button_info[]={
      {"xfce/stock_print",N_("Print"),tb_print,"sb_print",NULL,NULL,NULL,0},
      /*{"gtk-print",N_("Print"),tb_print,"sb_print","xfprint4",NULL,on_print_activate,GDK_P},*/
      /*{"gtk-print",N_("Print"),run_noterm,"sb_print","xfprint4",NULL,on_print_activate,GDK_P}, This enables dnd to the button but screws up normal button 
      pressing. Should check if run_noterm is still necessary now. */
      /*{"xfce/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,on_duplicate_activate,GDK_D},*/
      {"xfce/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate",NULL,NULL,NULL,0},
      /*{"xfce/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,on_symlink_activate,GDK_S},*/
      {"xfce/stock_convert",N_("Symlink"),sb_symlink,"sb_symlink",NULL,NULL,NULL,0},
      /*{"xfce/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,private_touch_activate,GDK_M},*/
      {"xfce/stock_index",N_("Touch"),sb_touch,"sb_touch",NULL,NULL,NULL,0},
      /*{"xfce/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,on_rename_activate,GDK_R},*/
      {"xfce/stock_save-as",N_("Rename"),sb_rename,"sb_rename",NULL,NULL,NULL,0},
      /*{"xfce/stock_no",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,on_scramble_activate,0},*/
      {"xfce/stock_no",N_("Scramble"),sb_scramble,"sb_scramble",NULL,NULL,NULL,0},
      /*{"xfce/stock_yes",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,on_unscramble_activate,0},*/
      {"xfce/stock_yes",N_("Unscramble"),sb_unscramble,"sb_unscramble",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };

#endif
  
    smart_button_init_t normal_button_info1[]={
      /* this is how to chuck in a separator */
      {"-","-",NULL,NULL,NULL,NULL,NULL},
      {"xfce/stock_cut",N_("Cut"),tb_cut,"nb_cut",NULL,NULL,NULL,0},
      {"xfce/stock_copy",N_("Copy"),tb_copy,"nb_copy",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t paste_button_info[]={
      {"xfce/stock_paste",N_("Paste"),tb_paste,"nb_paste",NULL,NULL,NULL,0},
      {"xfce/stock_pastelink",N_("Symlink"),tb_pastelink,"nb_pastelink",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t normal_button_info1b[]={
      {"xfce/stock_delete",N_("Remove"),tb_delete,"nb_remove",NULL,NULL,NULL,0},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    smart_button_init_t normal_button_info2[]={
      {"-","-",NULL,NULL,NULL,NULL,NULL},
      {"xfce/stock_refresh",N_("Refresh"),sb_refresh,"nb_refresh",NULL,NULL,NULL,GDK_Z},
      {"xfce/stock_quit",N_("Quit"),on_tb_off,"nb_close",NULL,NULL,NULL,GDK_Q},
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };
    
    smart_button_init_t popup_button_info[]={
      {"xfce/stock_dnd-multiple",N_("Duplicate"),sb_duplicate,"sb_duplicate2",NULL,NULL,treeview_duplicate_activate,0},
      {"xfce/stock_cut",N_("Cut"),tb_cut,"cut1",NULL,NULL,treeview_cut_activate,GDK_X},
      {"xfce/stock_copy",N_("Copy"),tb_copy,"copy1",NULL,NULL,treeview_copy_activate,GDK_C},
      {"xfce/stock_paste",N_("Paste"),tb_paste,"paste1",NULL,NULL,treeview_paste_activate,GDK_V},
#ifdef FOOL_INTL
      {"xfce/stock_open",N_("Open book"),NULL,"open_book2",NULL,NULL,on_open_book_activate,GDK_B},
      {"xfce/stock_open",N_("Default book"),NULL,"default_book2",NULL,NULL,on_defaultbook_activate,0},
      {"xfce/stock_question",N_("List books"),NULL,"remember1",NULL,NULL,on_rememberbook_activate,0},
      {"xfce/stock_new-tab",N_("New book"),NULL,"new4",NULL,NULL,on_newbook_activate,0},
      {"xfce/stock_save-as",N_("Save book"),NULL,"save_book2",NULL,NULL,on_save_book,0},
      {"xfce/stock_sort-ascending",N_("Purge"),NULL,"purge_bookmarks1",NULL,NULL,on_purge_bookmarks1_activate,0},
      {"xfce/stock_clear",N_("Clear"),NULL,"clear_all_bookmarks",NULL,NULL,on_clear_all_bookmarks_activate,0},
       {"xfce/stock_undo",N_("Remove item from frequent"),NULL,"undo_frequent",NULL,NULL,on_undo_history_activate,0},
      {"xfce/stock_undo",N_("Remove item from recent"),NULL,"undo_recent",NULL,NULL,on_undo_history_activate,0},
      {"xfce/stock_undo",N_("Remove item from book"),NULL,"remove_from_bookmarks",NULL,NULL,on_remove_from_bookmarks_activate,0},
      {"xfce/stock_delete",N_("Delete"),NULL,"remove",NULL,NULL,on_remove_activate,0},
      {"xfce/stock_question",N_("Set recent threshold"),NULL,"set_recent_threshold2",NULL,NULL,on_set_recent_threshold_activate,0},

#endif
      {NULL,NULL,NULL,NULL,NULL,NULL,NULL,0}
    };


    
    toggle_button_init_t toggle_columns_info[]={
      {N_("Date"),"date5",toggle_preference,(gpointer)((long)(SHOW_DATE|INDIVIDUAL_TOGGLE))},
      {N_("Size"),"size5",toggle_preference,(gpointer)((long)(SHOW_SIZE|INDIVIDUAL_TOGGLE))},
      {N_("UID"),"uid5",toggle_preference,(gpointer)((long)(SHOW_UID|INDIVIDUAL_TOGGLE))},
      {N_("GID"),"gid5",toggle_preference,(gpointer)((long)(SHOW_GID|INDIVIDUAL_TOGGLE))},
      {N_("Mode"),"mode5",toggle_preference,(gpointer)((long)(SHOW_MODE|INDIVIDUAL_TOGGLE))},
      {NULL,NULL}
    };
 

