
static
gboolean waste = TRUE;
G_MODULE_EXPORT
gboolean force_override = FALSE;
/* this *must* be thread safe, (hence _POSIX_PATH_MAX) */
G_MODULE_EXPORT
char child_file [_POSIX_PATH_MAX];

static int overwrite_dlg_result;
static
time_t initial;

static gint stop_watch;
static int child_mode;
static int nitems;
static long long lastsizeT;
static long long sizeT;
static int  countT;
static int child_path_number;
static FILE *plaintmpfile;
static void *rw_fork_obj;
static time_t deltatime;

static int rwStderr(int n, void *data);
static int rwStdout(int n, void *data);
static void rwForkOver(pid_t pid);
static void ChildTransfer(gpointer data);
static void set_innerloop(gboolean state);

static widgets_t *cpy_widgets_p;


static void close_it(widgets_t *widgets_p)
{
    gtk_main_quit();
    gtk_widget_destroy(widgets_p->remove);
    widgets_p->remove = NULL;
}

static gboolean on_destroy_event(GtkWidget * widget, GdkEvent * event, gpointer user_data)
{
    widgets_t *widgets_p = (widgets_t *)user_data; 
    overwrite_dlg_result = DLG_CANCEL;
    close_it(widgets_p);
    return TRUE;
}

static void on_copy_no_activate(GtkButton * button, gpointer user_data)
{
    widgets_t *widgets_p = (widgets_t *)user_data; 
    GtkWidget *check;
    overwrite_dlg_result = DLG_NO;
    check = lookup_widget(widgets_p->remove,"togglebutton1");
    force_override = gtk_toggle_button_get_active((GtkToggleButton *) check);
    if (force_override) overwrite_dlg_result = DLG_CANCEL;
    close_it(widgets_p);
}

static void on_copy_yes_activate(GtkButton * button, gpointer user_data)
{
    widgets_t *widgets_p = (widgets_t *)user_data; 
    GtkWidget *check;
    overwrite_dlg_result = DLG_YES;
    check = lookup_widget(widgets_p->remove,"togglebutton1");
    force_override = gtk_toggle_button_get_active((GtkToggleButton *) check);
	waste = FALSE;

    close_it(widgets_p);
}
static void on_copywaste_yes_activate(GtkButton * button, gpointer user_data)
{
    widgets_t *widgets_p = (widgets_t *)user_data; 
    GtkWidget *check;
    overwrite_dlg_result = DLG_YES;
    check = lookup_widget(widgets_p->remove,"togglebutton1");
    force_override = gtk_toggle_button_get_active((GtkToggleButton *) check);
	waste = TRUE;

    close_it(widgets_p);
}


static int make_overwrite_dialog(widgets_t *widgets_p, const gchar *err, const gchar *target, const gchar *src)
{
    gchar *mess;
    struct stat st;

    waste = TRUE;
    widgets_p->remove = xffm_create_remove(widgets_p);

    g_signal_connect(lookup_widget(widgets_p->remove,"cancelbutton"), "clicked", G_CALLBACK(on_copy_no_activate), widgets_p);
    g_signal_connect(lookup_widget(widgets_p->remove,"removebutton"), "clicked", G_CALLBACK(on_copy_yes_activate), widgets_p);
    g_signal_connect(lookup_widget(widgets_p->remove,"wastebutton"), "clicked", G_CALLBACK(on_copywaste_yes_activate), widgets_p);

    g_signal_connect(widgets_p->remove, "delete-event", G_CALLBACK(on_destroy_event), widgets_p);
    g_signal_connect(widgets_p->remove, "destroy-event", G_CALLBACK(on_destroy_event), widgets_p);

    /* dialog specifics */
   
    if(err)
    {
	char mess[_POSIX_PATH_MAX];
	sprintf(mess, _("Try again (%s)?"), err);
	gtk_label_set_text((GtkLabel *) lookup_widget(widgets_p->remove,"label16"), mess);
	hideit(widgets_p->remove, "question");
    }
    else
    {
	gtk_label_set_text((GtkLabel *) lookup_widget(widgets_p->remove,"label16"), _("Warning"));
	hideit(widgets_p->remove, "warning");
    }

    gtk_label_set_text((GtkLabel *) lookup_widget(widgets_p->remove,"label22"), _("Overwrite"));    

    lstat(target,&st);
    if (src){
       struct stat s_st;
       gchar *t1=NULL,*t2=NULL;
       gchar *s1=NULL,*s2=NULL;
       if (lstat(src,&s_st)<0){
	   g_warning("cannot stat %s",src);
       }
       {
	   s1=g_strdup(time_to_string(s_st.st_mtime));
	   s2=g_strdup(sizetag((off_t)s_st.st_size,-1));
	   t1=g_strdup(my_utf_string(target));
	   t2=g_strdup(my_utf_string(src));
       }
       mess=g_strdup_printf(_("Overwrite %s\n(%s %s)\n with \n%s\n(%s %s)?"),
	      t1,time_to_string(st.st_mtime),sizetag((off_t)st.st_size, -1),
	      t2,s1,s2);
       g_free(s1);
       g_free(s2);
       g_free(t1);
       g_free(t2);
    } else {
       mess=g_strdup_printf("%s\n(%s %s)",
	       (target),time_to_string(st.st_mtime), sizetag((off_t)st.st_size, -1)); 
    }

    gtk_label_set_text((GtkLabel *) lookup_widget(widgets_p->remove,"label20"), mess);
    g_free(mess);mess=NULL;
    {
      GdkPixbuf	*pb;
      GtkImage *image=(GtkImage *)lookup_widget(widgets_p->remove,"adicon");
      pb = icon_tell(widgets_p, MEDIUM, "xfce/waste_basket_full");
      if (pb) {
	gtk_image_set_from_pixbuf (image, pb);
	g_object_unref (G_OBJECT (pb));
      }
    }

    gtk_widget_realize(widgets_p->remove);
    place_dialog(widgets_p->window, widgets_p->remove);
    gtk_widget_show(widgets_p->remove);
    if (getenv("XFFM_DEFAULT_UNLINK") && strcmp(getenv("XFFM_DEFAULT_UNLINK"),"unlink")==0){
	  gtk_widget_grab_focus (lookup_widget(widgets_p->remove,"removebutton"));	    
    }
    else if (getenv("XFFM_DEFAULT_UNLINK") && strcmp(getenv("XFFM_DEFAULT_UNLINK"),"waste")==0){
	  gtk_widget_grab_focus (lookup_widget(widgets_p->remove,"wastebutton"));	    
    }

    if (widgets_p->type != DESKVIEW_TYPE) {
	gtk_window_set_transient_for(GTK_WINDOW(widgets_p->remove), 
		    GTK_WINDOW(widgets_p->window));
    }
    
    if (strstr(target,"/..Wastebasket"))    {
	hideit(widgets_p->remove, "wastebutton");
    }

    gtk_main();
    return overwrite_dlg_result;
}






static void get_selection(GtkTreeModel * treemodel, GtkTreePath * path, GtkTreeIter * iter, gpointer data)
{
    record_entry_t *en;
    gtk_tree_model_get(treemodel, iter, ENTRY_COLUMN, &en, -1);
    if (en && en->path) fprintf(plaintmpfile, "%d\t%s\t%s\n", TR_COPY, en->path, en->path);
    return;
}



static gchar *mktgpath(char *target_dir, char *source)
{
    gchar *name = g_path_get_basename(source);
    gchar *target = g_build_filename(target_dir,name,NULL);
    g_free(name);
    return target;
}

static int ok_input(char *target, record_entry_t * s_en)
{
    /*struct stat tgt_stat;*/
    /*gboolean target_exists = TRUE;*/

    if(IS_XF_FIFO(s_en->type) || IS_XF_CHR(s_en->type) || IS_XF_BLK(s_en->type) || IS_XF_SOCK(s_en->type))
    {
        print_diagnostics(cpy_widgets_p,"xfce/error", strerror(EBADF)," : ", s_en->path, " --> ", target,"\n", NULL);
        return (DLG_CONTINUE);
    }
    
    if (!g_file_test(target,G_FILE_TEST_EXISTS))return (DLG_CONTINUE);
    /*if(stat(target, &tgt_stat) < 0) return (DLG_CONTINUE);*/

#if 0
/* inode determination */
    if (tgt_stat.st_ino == s_en->st->st_ino){
	print_diagnostics(cpy_widgets_p,"xfce/error",strerror(EEXIST)," : ", s_en->path, " --> ", target,"\n", NULL);
	return (DLG_CONTINUE);
    }
#endif
    try_again:
    overwrite_dlg_result = DLG_YES;
    xffm_warn_target_exists(cpy_widgets_p,target, s_en->path);
    if(overwrite_dlg_result == DLG_YES && waste){
	if(!xffm_waste(cpy_widgets_p, target))
	{
	    /* error message set within wasteit() */
	    goto try_again;
	}
    }
    return overwrite_dlg_result;
}


static void ChildTransfer(gpointer data)
{
    	
    lastsizeT=0;
    child_path_number = 0;
    sizeT = 0;
    deltatime = 100001;


    /* child */
#define MAX_ARGUMENTS 102
    {
	FILE *tfile;
	static gchar *sources[MAX_ARGUMENTS];
	gchar line[MAX_LINE_SIZE+1];
	int i,initial_i;
	gchar *tgt=NULL;
	int this_count=0;
	
	if (!countT) {
	    fprintf(stdout,"child:Nothing to transfer!\n"); 
	    _exit(123);
	}
	if ((tfile = fopen(child_file, "r"))==NULL) {
	    fprintf(stdout,"child:open: %s %s\n",strerror(errno),child_file); 
	    _exit(123);
	}
	memset((void *)line,0,MAX_LINE_SIZE+1);
	i=0;
	if (child_mode & TR_MOVE) sources[i++] = "mv";
	else if(child_mode & TR_LINK) {
	    sources[i++] = "ln"; 
	    sources[i++] = "-s"; 
	    sources[i++] = "-v"; 
	
	} else { 
	    sources[i++] = "cp"; 
	    sources[i++] = "-p"; 
	    sources[i++] = "-R";
	    /* follow symlinks on command line? */
	    sources[i++] = "-H";
	}  
	sources[i++] = "-f";
	sources[i++] = "-v";
	initial_i=i;
	while (!feof(tfile)){
	    int status;
	    for (i=initial_i; 
		    i<MAX_ARGUMENTS-2 && !feof(tfile) && fgets(line, MAX_LINE_SIZE - 1, tfile); 
		    i++) 
	    {
		int type;
		gchar *source, *target;
		type = atoi(strtok(line, "\t"));
		source = strtok(NULL, "\n");
		target = strrchr(source, '\t') + 1;
		*(strrchr(source, '\t')) = 0;
		sources[i] = g_strdup(source);
		if (!tgt) {
		    if (child_mode & TR_DUPLICATE) tgt=g_strdup(target);
		    else tgt = g_path_get_dirname(target);
		}
	    }
	    sources[i++]=tgt;
	    sources[i]=NULL;
#ifdef DEBUG
	    {
		int j;
		for (j=0; j<i; j++){
		    fprintf(stderr,"child:argument %d: %s\n",j,sources[j]);
		}
		fprintf(stderr,"child:forking %s with %d arguments\n",sources[0],i);
	    }
#endif
	    if (fork()==0){
		execvp(sources[0],sources);
		fprintf(stderr,"child:error on execvp(%s)!\n",sources[0]);
		_exit(123);
	    } else {
		wait(&status);
		this_count += (i-initial_i-1);
    		fprintf(stdout,"child:%s %d/%d\n",sources[0],this_count,countT);
		usleep(100);
	    }

	}
	fclose(tfile);
    }
    
	    
    /*printf("child:finished all forks!\n");  */
    _exit(123);
}

/* function to clean up the mess after child process
 * has been sent a SIGTERM. (Might a unlink target be 
 * good here?)
 * */
static void cpyForkCleanup(void)
{
    /* break inner gtk_main() loop */
#ifdef DEBUG
    fprintf(stderr,"dbg:call to innerloop from forkcleanup\n"); 
#endif
    set_innerloop(FALSE);
    /* unlink(fork_target); */
}

static gint watch_stop(gpointer data)
{
    time_t current=time(NULL);
    if (current - initial != deltatime) {
	gchar *g;
	deltatime = current - initial;
	/*g=g_strdup_printf("cp/mv %ld %s",(long)(deltatime),_("seconds"));*/
	g=g_strdup_printf(_("cp/mv: %ld seconds"),(long)(deltatime));
	print_status(cpy_widgets_p,"xfce/warning",g,NULL);
	g_free(g);
    }
    if (!rw_fork_obj) return FALSE;
    if(cpy_widgets_p->stop)
    {
	print_status(cpy_widgets_p,"xfce/error",strerror(ECANCELLED),NULL);
	cpy_widgets_p->stop = FALSE;
	hide_stop(cpy_widgets_p);
	cursor_reset(cpy_widgets_p->window);
	rw_fork_obj = TuboCancel(rw_fork_obj, cpyForkCleanup);
	return FALSE;
    }
    if (cpy_widgets_p->progress) {
	gtk_widget_show(cpy_widgets_p->progress);
	gtk_progress_bar_pulse((GtkProgressBar *)cpy_widgets_p->progress);
	process_pending_gtk();
    }
    /*set_progress_generic(cpy_widgets_p->progress,-1,-1,1);*/
    return TRUE;
}

static void set_innerloop(gboolean state)
{
    static gboolean innerloop = FALSE;
    if(state == innerloop)
	return;
    innerloop = state;
    /*fprintf(stderr,"dbg:innerloop %s\n",(state)?"started":"terminated");fflush(NULL); */
    if(state){
	stop_watch = g_timeout_add_full(0,260, (GtkFunction) watch_stop, NULL,NULL);
       	gtk_main();
    }
    else {
	g_source_remove(stop_watch);
	gtk_main_quit();
    }
}

/* function to process stderr produced by child */
static int rwStderr(int n, void *data)
{
    char *line;

    if(n)
	return TRUE;		/* this would mean binary data */
    line = (char *)data;
#ifdef DEBUG
    fprintf(stderr, "child stderr:%s\n", line);
#endif
    if (strlen(line)==0 || line[0]=='\n') return TRUE;
    print_diagnostics(cpy_widgets_p,"xfce/error", line, NULL);
    process_pending_gtk();
    return TRUE;
}


/* function to process stdout produced by child */
static int rwStdout(int n, void *data)
{
    char *line, *texto;

    if(n)
	return TRUE;		/* this would mean binary data */
    line = (char *)data;


#ifdef DEBUG
    fprintf(stderr,"dbg(rwStdout):%s",line);fflush(NULL); 
#endif
    
    /* only process child specific lines: */
    if(strncmp(line, "child:", strlen("child:")) != 0)
    {
	if (strlen(line)==0 || line[0]=='\n') return TRUE;
	print_diagnostics(cpy_widgets_p,"xfce/info", line, NULL);
	process_pending_gtk();
	return TRUE;
    }

    /* anything else is a process_error() and operation
     * should continue with a diagnostics message.  */
    strtok(line, ":");
    texto = strtok(NULL, "\n");
    print_diagnostics(cpy_widgets_p,NULL, texto, "\n", NULL);
    process_pending_gtk();
    return TRUE;
}

/* function called when child is dead */
static void rwForkOver(pid_t pid)
{
    char secs[1024];
    rw_fork_obj = NULL;
#ifdef DEBUG
    fprintf(stderr,"dbg: call to innerloop from forkover()\n");fflush(NULL); 
#endif
    set_innerloop(FALSE);
    if (cpy_widgets_p->progress) gtk_widget_hide(cpy_widgets_p->progress);
    /*set_progress_generic(cpy_widgets_p->progress,-1, -1,1);*/
    sprintf(secs, _("Finished (%d/%d) : %ld seconds"), nitems, countT, (long)(time(NULL) - initial));
    print_status(cpy_widgets_p,"xfce/info", secs, NULL);
    hide_stop(cpy_widgets_p);
    cursor_reset(cpy_widgets_p->window);
    cpy_widgets_p->stop = FALSE;
}


